<template>
  <div class="h-100">
    <ob-table
      :columns="columns"
      :items="dataSource"
      :functional-panel="true"
      :tableLayoutFixed="false"
      :is-functional-group="false"
      :is-functional-sort="false"
      @select="selectedRow"
    >
      <template v-slot:comment="{ data }">
        <i class="icon edit"></i>
      </template>
    </ob-table>
    <ObModal title="Категории стоимости" ref="popup" title-second="редактирование">
      <risks-popup
        @changed="changeHandler"
        @close="$refs.popup.close()"
        :data-source="selectedRowData"
      />
    </ObModal>
  </div>
</template>

<script>
import api from "@/api";
import ObModal from "common-components/src/obComponents/obModal";
import RisksPopup from "./modal/RisksPopup";
import ObTable from "common-components/src/obComponents/obTable/index";

export default {
  components: {
    ObTable,
    RisksPopup,
    ObModal
  },
  riskOptions: {
    HIGH: 'Высокий',
    MEDIUM: 'Средний',
    LOW: 'Низкий'
  },
  data() {
    return {
      propertyId: "uuid",
      selectedRowData: {},
      rules: {},
      editTitle: "Категория стоимости",
      index: 0,
      dataSource: []
    };
  },

  methods: {
    async fetch() {
      try {
        const risks = await api.risks.getCargoLostRisk();
        this.dataSource = risks.data.cargoTypes;
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    },

    selectedRow(row) {
      this.selectedRowData = row;
      this.$refs.popup.open();
    },

    async changeHandler({ uuid, probabilityLevel, ftlAvgPrice }) {
      const payload = { probabilityLevel, ftlAvgPrice };
      try {
        await api.risks.putCargoLostRisk(uuid, payload);
        this.fetch();
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
      }
    }
  },

  computed: {
    columns() {
      return [
        {
          title: "Код",
          key: "code",
          html: (data) => {
            return this.dataSource.indexOf(data) + 1;
          }
        },
        {
          title: "Тип груза",
          key: "title"
        },
        {
          title: "Риск утраты",
          key: "probabilityLevel",
          html: data => {
            return data.probabilityLevel === 'HIGH' ? `<i class="icon alert"></i>${this.$options.riskOptions[data.probabilityLevel]}` : this.$options.riskOptions[data.probabilityLevel]
          }
        },
        {
          title: "Средняя стоимость фуры, ₽ без НДС",
          key: "ftlAvgPrice",
          exactWidth: "163px",
          html: ({ ftlAvgPrice }) => ftlAvgPrice ?? "Не указана"
        },
        {
          titie: "",
          key: "comment",
          slotName: "comment",
          isToggleDisabled: true,
        }
      ];
    }
  },

  async created() {
    this.fetch();
  }
};
</script>

<style lang="scss" scoped>
.pr-cat {
  height: 100%;
}
.data-grid__footer,
.dx-pager {
  background: $background-color-light;
}
.dx-datagrid-action {
  width: 300px !important;
}

::v-deep {
  .edit {
    opacity: 0;
  }

  tr:hover .edit {
    opacity: 1;
  }

  .alert {
    margin-right: 5px;
    font-size: 16px;
    font-weight: 700;
    color: $color-error;
  }
}
</style>
